## libdnf 0.75.0

=== CMakeLists.txt ===
# cmake requirements and policies
cmake_minimum_required(VERSION 3.5.0)
# Avoid a warning because "hth" links to
# the in-tree libhawkey, but uses pkg-config to find
# GLib.  There may be a better way to do this...
cmake_policy(SET CMP0003 NEW)

# print initial information about the project
message("Running CMake on libdnf...")
project(libdnf C CXX)

# GNUInstallDirs requires a language set with project()
include(GNUInstallDirs)

# use project specific cmake modules
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/modules)
if(${CMAKE_VERSION} VERSION_LESS 3)
    set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH};${CMAKE_SOURCE_DIR}/cmake/modules-cmake-2)
endif()


# print exact name and version of the compiled project
include(VERSION.cmake)
message("Building ${PROJECT_NAME} version: ${LIBDNF_VERSION}")


# build options
option(WITH_BINDINGS "Enables python/SWIG bindings" ON)
option(ENABLE_STATIC "Build a static library instead of shared" OFF)
option(WITH_GTKDOC "Enables libdnf GTK-Doc HTML documentation" ON)
option(WITH_HTML "Enables hawkey HTML generation" ON)
option(WITH_MAN "Enables hawkey man page generation" ON)
option(WITH_ZCHUNK "Build with zchunk support" ON)
option(ENABLE_DNF5_CONF_DROP_IN "Build with support for libdnf5 drop-in configuration directories?" ON)
option(ENABLE_DNF5_CONF_REPOS_OVERRIDE "Build with support for libdnf5 repository configuration overrides?" ON)
option(ENABLE_RHSM_SUPPORT "Build with Red Hat Subscription Manager support?" OFF)
option(ENABLE_SOLV_URPMREORDER "Build with support for URPM-like solution reordering?" OFF)
option(WITH_TESTS "Enables unit tests" ON)


# build options - debugging
option(WITH_SANITIZERS "Build with address, leak and undefined sanitizers (DEBUG ONLY)" OFF)


# always place our header files before system ones
include_directories(${CMAKE_SOURCE_DIR} libdnf/utils/)

# load pkg-config first; it's required by other modules
find_package(PkgConfig REQUIRED)
if(APPLE)
    set(ENV{PKG_CONFIG_PATH} "$ENV{PKG_CONFIG_PATH}:/usr/local/lib64/pkgconfig")
    set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH};/usr/local/share/cmake/Modules/)
    include_directories(/usr/local/include)
endif()


# build dependencies
find_package(LibSolv 0.7.21 REQUIRED COMPONENTS ext)


# build dependencies via pkg-config
pkg_check_modules(GLIB REQUIRED gio-unix-2.0>=2.46.0)
include_directories(${GLIB_INCLUDE_DIRS})
pkg_check_modules(JSONC REQUIRED json-c)
include_directories(${JSONC_INCLUDE_DIRS})
pkg_check_modules(LIBMODULEMD REQUIRED modulemd-2.0>=2.11.2)
pkg_check_modules(REPO REQUIRED librepo>=1.18.0)
include_directories(${REPO_INCLUDE_DIRS})
link_directories(${REPO_LIBRARY_DIRS})

pkg_check_modules(RPM REQUIRED rpm>=4.15.0)
if (RPM_VERSION VERSION_GREATER_EQUAL "5.99.90")
    add_definitions(-DRPM_AUTOADDS_SUBKEYS)
endif()

pkg_check_modules(SMARTCOLS REQUIRED smartcols)
pkg_check_modules(SQLite3 REQUIRED sqlite3)

if (WITH_ZCHUNK)
    pkg_check_modules(ZCHUNKLIB zck>=0.9.11 REQUIRED)
    set (CMAKE_CXX_FLAGS          "${CMAKE_CXX_FLAGS} -DWITH_ZCHUNK")
    set (CMAKE_CXX_FLAGS_DEBUG    "${CMAKE_CXX_FLAGS_DEBUG} -DWITH_ZCHUNK")
endif ()

if(ENABLE_RHSM_SUPPORT)
    pkg_check_modules(RHSM REQUIRED librhsm>=0.0.3)
    include_directories(${RHSM_INCLUDE_DIRS})
endif()


# glibc: check if fnmatch.h has FNM_CASEFOLD symbol
include(CheckSymbolExists)
list(APPEND CMAKE_REQUIRED_DEFINITIONS -D_GNU_SOURCE)
check_symbol_exists(FNM_CASEFOLD "fnmatch.h" HAS_FNM_CASEFOLD)
if(NOT HAS_FNM_CASEFOLD)
    message(SEND_ERROR "FNM_CASEFOLD is not available in fnmatch.h")
endif()

# python
if(WITH_BINDINGS)
    if(NOT PYTHON_DESIRED)
        find_package(PythonInterp REQUIRED)
    elseif(${PYTHON_DESIRED} STREQUAL "2")
        find_package(PythonInterp 2 EXACT REQUIRED)
    elseif(${PYTHON_DESIRED} STREQUAL "3")
        find_package(PythonInterp 3 EXACT REQUIRED)
    elseif(EXISTS ${PYTHON_DESIRED})
        set(PYTHON_EXECUTABLE ${PYTHON_DESIRED})
        find_package(PythonInterp REQUIRED)
    else()
        message(FATAL_ERROR "Invalid PYTHON_DESIRED value: " ${PYTHON_DESIRED})
    endif()
    find_package(PythonLibs REQUIRED)
    message(STATUS "Building for python${PYTHON_VERSION_MAJOR}")
else()
    message(STATUS "Not building language bindings")
endif()


# compiler options
add_compile_options(-Wcast-align -Wno-uninitialized -Wredundant-decls -Wwrite-strings -Wformat-nonliteral -Wmissing-format-attribute -Wsign-compare -Wtype-limits -Wuninitialized -Wall -Wl,--as-needed)
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu11 -Wmissing-prototypes -Waggregate-return -Wshadow -Werror=implicit-function-declaration")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -Wmissing-declarations")

# apple: turn rpath off
set(CMAKE_MACOSX_RPATH 0)

# package/project version
add_definitions(-DPACKAGE_VERSION="${LIBDNF_VERSION}")

# The libdnf API is under development now. This enables it for internal usage.
add_definitions(-DLIBDNF_UNSTABLE_API)

# gettext
add_definitions(-DGETTEXT_DOMAIN="libdnf")
add_definitions(-DG_LOG_DOMAIN="libdnf")

# tests
add_definitions(-DTESTDATADIR="${CMAKE_SOURCE_DIR}/data/tests")

# Use libdnf5 drop-in configuration directories including distribution configuration.
if(ENABLE_DNF5_CONF_DROP_IN)
    add_definitions(-DDNF5_CONF_DROP_IN)
endif()

# Use libdnf5 repository overrides. Save repo conf chnges to "99-config_manager.repo" override.
if(ENABLE_DNF5_CONF_REPOS_OVERRIDE)
    add_definitions(-DDNF5_CONF_REPOS_OVERRIDE)
endif()

# librhsm
if(ENABLE_RHSM_SUPPORT)
    add_definitions(-DRHSM_SUPPORT)
endif()

# libsolv
if(ENABLE_SOLV_URPMREORDER)
    add_definitions(-DLIBSOLV_FLAG_URPMREORDER=1)
endif()

# If defined, libsolv adds the prefix "dep_" to solvable dependencies.
# As a result, `requires` is renamed to `dep_requires`.
# Needed for C++20. `requires` is a keyword in C++20.
add_definitions(-DLIBSOLV_SOLVABLE_PREPEND_DEP)

if(WITH_SANITIZERS)
    message(WARNING "Building with sanitizers enabled!")
    add_compile_options(-fsanitize=address -fsanitize=undefined -fsanitize=leak)
    link_libraries(asan ubsan)
endif()


# build binaries
add_subdirectory(libdnf)
if(WITH_BINDINGS)
    # add_subdirectory(bindings/perl)
    add_subdirectory(bindings/python)
endif()


# build translations
add_subdirectory(po)


# build docs
add_subdirectory(docs/libdnf)
if(WITH_BINDINGS)
    add_subdirectory(docs/hawkey)
endif()


# build tests
IF (WITH_TESTS)
enable_testing()
add_subdirectory(tests)
ENDIF()
if(WITH_BINDINGS)
    add_subdirectory(python/hawkey)
endif()


add_subdirectory(etc)

=== .copr/Makefile ===
# Copyright David Cantrell <dcantrell@redhat.com>
# SPDX-License-Identifier: GPL-3.0-or-later

# Set the top level source directory
topdir := $(shell realpath $(dir $(lastword $(MAKEFILE_LIST)))/..)

# Install packages before anything else
_install := $(shell dnf install -y git)
_safedir := $(shell git config --global --add safe.directory $(topdir))

# Pass BUILDTYPE=release to generate a release SRPM
BUILDTYPE ?= copr

# Spec file and template
SPEC_TEMPLATE = $(shell ls -1 $(topdir)/*.spec)
SPEC = $(topdir)/$(shell basename $(SPEC_TEMPLATE))

# Replace placeholders in the spec file template
RPMDATE = $(shell date +'%a %b %d %Y')
#RPMAUTHOR = $(shell git log | grep ^Author: | head -n 1 | cut -d ' ' -f 2,3,4)
RPMAUTHOR = David Cantrell <dcantrell@redhat.com>

# Various things we need to generate a tarball
PKG = $(shell rpmspec -P "$(SPEC_TEMPLATE)" | grep ^Name: | awk '{ print $$2; }')
VER = $(shell rpmspec -P "$(SPEC_TEMPLATE)" | grep ^Version: | awk '{ print $$2; }')

ifeq ($(BUILDTYPE),copr)
GITDATE          = $(shell date +'%Y%m%d%H%M')
GITHASH          = $(shell git rev-parse --short HEAD)
TARBALL_BASENAME = $(PKG)-$(VER)-$(GITDATE)git$(GITHASH)
TAG              = HEAD
else
0TAG             = $(shell git tag -l | sort -V | tail -n 1)
endif

ifeq ($(BUILDTYPE),release)
TARBALL_BASENAME = $(PKG)-$(VER)
endif

# Where to insert the changelog entry
STARTING_POINT = $(shell expr $(shell grep -n ^%changelog "$(SPEC)" | cut -d ':' -f 1) + 1)

srpm:
	sed -i -e '1i %global source_date_epoch_from_changelog 0' "$(SPEC)"
	sed -e 's|%%VERSION%%|$(VER)|g' < "$(SPEC_TEMPLATE)" > "$(SPEC)".new
	mv "$(SPEC)".new "$(SPEC)"
ifeq ($(BUILDTYPE),copr)
	sed -i -e '/^Release:/ s/1[^%]*/0.1.$(GITDATE)git$(GITHASH)/' "$(SPEC)"
	sed -i -e 's|^Source0:.*$$|Source0: $(TARBALL_BASENAME).tar.gz|g' "$(SPEC)"
	sed -i -e 's|^%autosetup.*$$|%autosetup -n $(TARBALL_BASENAME)|g' "$(SPEC)"
	sed -i -e '$(STARTING_POINT)a\\' "$(SPEC)"
	sed -i -e '$(STARTING_POINT)a - Build $(PKG)-$(VER)-$(GITDATE)git$(GITHASH) snapshot' "$(SPEC)"
	sed -i -e '$(STARTING_POINT)a * $(RPMDATE) $(RPMAUTHOR) - $(VER)-$(GITDATE)git$(GITHASH)' "$(SPEC)"
endif
	git archive \
		--format=tar \
		--output='$(topdir)/$(TARBALL_BASENAME).tar' \
		--prefix='$(TARBALL_BASENAME)/' $(TAG) $(topdir)
	gzip -9f $(topdir)/$(TARBALL_BASENAME).tar
	rpmbuild \
		-bs --nodeps \
		--define "_sourcedir $(topdir)" \
		--define "_srcrpmdir $(outdir)" \
		--define "_rpmdir $(outdir)" "$(SPEC)"

=== etc/CMakeLists.txt ===
if(WITH_SANITIZERS)
    INSTALL (FILES "dnf-sanitizers.sh" DESTINATION /etc/profile.d/)
endif()

=== libdnf/CMakeLists.txt ===
set(LIBDNF_SRCS
    dnf-advisorypkg.cpp
    dnf-advisoryref.cpp
    dnf-advisory.cpp
    hy-goal.cpp
    hy-iutil.cpp
    log.cpp
    nevra.cpp
    nsvcap.cpp
    dnf-reldep.cpp
    dnf-reldep-list.cpp
    hy-package.cpp
    hy-packageset.cpp
    hy-query.cpp
    dnf-sack.cpp
    hy-selector.cpp
    hy-subject.cpp
    hy-util.cpp
    dnf-db.cpp
    dnf-conf.cpp
    dnf-context.cpp
    dnf-goal.cpp
    dnf-keyring.cpp
    dnf-lock.cpp
    dnf-package.cpp
    dnf-packagedelta.cpp
    dnf-repo-loader.cpp
    dnf-rpmts.cpp
    dnf-repo.cpp
    dnf-state.cpp
    dnf-transaction.cpp
    dnf-utils.cpp
)

include_directories(transaction)
add_subdirectory("transaction")

if(CMAKE_SIZEOF_VOID_P EQUAL 8)
    set(MULTILIB_ARCH "64")
    configure_file("config-64.h.in" ${CMAKE_CURRENT_SOURCE_DIR}/config-64.h)
elseif(CMAKE_SIZEOF_VOID_P EQUAL 4)
    set(MULTILIB_ARCH "32")
    configure_file("config-64.h.in" ${CMAKE_CURRENT_SOURCE_DIR}/config-32.h)
endif()
configure_file("dnf-version.h.in"  ${CMAKE_CURRENT_SOURCE_DIR}/dnf-version.h)
configure_file("libdnf.pc.in" ${CMAKE_CURRENT_BINARY_DIR}/libdnf.pc @ONLY)

add_subdirectory(goal)
add_subdirectory(repo)
add_subdirectory(module)
add_subdirectory(utils)
add_subdirectory(conf)
add_subdirectory(sack)
add_subdirectory(plugin)

set(LIBDNF_SRCS ${LIBDNF_SRCS} ${GOAL_SOURCES})
set(LIBDNF_SRCS ${LIBDNF_SRCS} ${MODULE_SOURCES})
set(LIBDNF_SRCS ${LIBDNF_SRCS} ${UTILS_SOURCES})
set(LIBDNF_SRCS ${LIBDNF_SRCS} ${CONF_SOURCES})
set(LIBDNF_SRCS ${LIBDNF_SRCS} ${SACK_SOURCES})
set(LIBDNF_SRCS ${LIBDNF_SRCS} ${REPO_SOURCES})
set(LIBDNF_SRCS ${LIBDNF_SRCS} ${PLUGIN_SOURCES})

if(ENABLE_STATIC)
    add_library(libdnf STATIC ${LIBDNF_SRCS})
else()
    add_library(libdnf SHARED ${LIBDNF_SRCS})
endif()
target_link_libraries(libdnf
    ${CMAKE_DL_LIBS}
    ${REPO_LIBRARIES}
    ${GLIB_LIBRARIES}
    ${GLIB_GOBJECT_LIBRARIES}
    ${GLIB_GIO_LIBRARIES}
    ${GLIB_GIO_UNIX_LIBRARIES}
    ${LIBSOLV_LIBRARY}
    ${LIBSOLV_EXT_LIBRARY}
    ${RPM_LIBRARIES}
    ${SCOLS_LIBRARIES}
    ${SQLite3_LIBRARIES}
    ${JSONC_LIBRARIES}
    ${LIBMODULEMD_LIBRARIES}
    ${SMARTCOLS_LIBRARIES}
)

if(ENABLE_RHSM_SUPPORT)
    target_link_libraries(libdnf ${RHSM_LIBRARIES})
endif()

set(DNF_SO_VERSION 2)
set_target_properties(libdnf PROPERTIES OUTPUT_NAME "dnf")
set_target_properties(libdnf PROPERTIES SOVERSION ${DNF_SO_VERSION})

set(LIBHAWKEY_headers
    hy-goal.h
    hy-nevra.h
    hy-package.h
    hy-packageset.h
    hy-query.h
    hy-repo.h
    hy-selector.h
    hy-subject.h
    hy-types.h
    hy-util.h
)

set(LIBDNF_headers
    config.h
    log.hpp
    nevra.hpp
    nsvcap.hpp
    dnf-advisory.h
    dnf-advisorypkg.h
    dnf-advisoryref.h
    dnf-db.h
    dnf-conf.h
    dnf-context.h
    dnf-enums.h
    dnf-goal.h
    dnf-keyring.h
    dnf-lock.h
    dnf-package.h
    dnf-packagedelta.h
    dnf-repo-loader.h
    dnf-rpmts.h
    dnf-sack.h
    dnf-reldep.h
    dnf-reldep-list.h
    dnf-repo.h
    dnf-state.h
    dnf-transaction.h
    dnf-types.h
    dnf-utils.h
    dnf-version.h
    libdnf.h
)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libdnf.pc
    DESTINATION ${CMAKE_INSTALL_FULL_LIBDIR}/pkgconfig
)
install(FILES ${LIBDNF_headers} DESTINATION include/libdnf)
install(FILES ${LIBHAWKEY_headers} DESTINATION include/libdnf)
install(TARGETS libdnf LIBRARY DESTINATION ${CMAKE_INSTALL_FULL_LIBDIR})
install(FILES "README.plugins" DESTINATION "${CMAKE_INSTALL_FULL_LIBDIR}/libdnf/plugins" RENAME "README")

=== plugins/Makefile ===
all: example_plugin

example_plugin: example_plugin.c
	gcc -fPIC -shared $(shell pkg-config --cflags --libs libdnf) -Wcast-align -Wno-uninitialized -Wredundant-decls -Wwrite-strings -Wformat-nonliteral -Wmissing-format-attribute -Wsign-compare -Wtype-limits -Wuninitialized -Wall -Werror=implicit-function-declaration -Wl,--as-needed -Wmissing-prototypes -Waggregate-return -Wshadow -o example_plugin.so example_plugin.c

=== tests/CMakeLists.txt ===
pkg_check_modules(CHECK REQUIRED check)
pkg_check_modules(CPPUNIT REQUIRED cppunit)

add_subdirectory(libdnf/conf)
add_subdirectory(libdnf/module/modulemd)
add_subdirectory(libdnf/module)
add_subdirectory(libdnf/repo)
add_subdirectory(libdnf/transaction)
add_subdirectory(libdnf/sack)
add_subdirectory(hawkey)
add_subdirectory(libdnf)

set(LIBDNF_TEST_SOURCES
    ${LIBDNF_TEST_SOURCES}
    ${CMAKE_CURRENT_SOURCE_DIR}/run_tests.cpp
)

add_executable(run_tests ${LIBDNF_TEST_SOURCES} ${LIBDNF_TEST_HEADERS})
target_link_libraries(run_tests libdnf cppunit)

add_test(NAME test_cpp COMMAND ${CMAKE_CURRENT_BINARY_DIR}/run_tests DEPENDS run_tests COMMENT "Running CPPUNIT tests...")
set_property(TEST test_cpp PROPERTY ENVIRONMENT "LD_LIBRARY_PATH=${CMAKE_BINARY_DIR}/libdnf")

=== bindings/perl/CMakeLists.txt ===
find_package(SWIG REQUIRED)
include(UseSWIG)


message("Building for perl")
find_package(Perl REQUIRED)
find_package(PerlLibs REQUIRED)


include_directories(${CMAKE_SOURCE_DIR})
include_directories(${PERL_INCLUDE_PATH})
include(UseSWIG)


set_source_files_properties(../swig/utils.i PROPERTIES CPLUSPLUS ON)
swig_add_module(utils perl ../swig/utils.i)
swig_link_libraries(utils libdnf)
swig_link_libraries(utils ${PERL_LIBRARY})
swig_link_libraries(utils ${SQLite3_LIBRARIES})

set_source_files_properties(../swig/transaction.i PROPERTIES CPLUSPLUS ON)
swig_add_module(transaction perl ../swig/transaction.i)
swig_link_libraries(transaction libdnf)
swig_link_libraries(transaction ${PERL_LIBRARY})

=== docs/hawkey/CMakeLists.txt ===
# html and man documentation are separate targets, apparently there's no way to
# tell sphinx-build to do them both in one go:


if (WITH_HTML OR WITH_MAN)
    find_program(SPHINX_PROGRAM NAMES "sphinx-build-${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR}")
    if(NOT EXISTS ${SPHINX_PROGRAM})
        find_program(SPHINX_PROGRAM NAMES sphinx-build-${PYTHON_VERSION_MAJOR})
    endif()
    if(NOT EXISTS ${SPHINX_PROGRAM})
        find_program(SPHINX_PROGRAM NAMES sphinx-build)
    endif()
    if(NOT EXISTS ${SPHINX_PROGRAM})
        message(FATAL_ERROR "Sphinx program not found." )
    endif()
endif()

if(WITH_HTML)
    add_custom_target(doc-html
        PYTHONPATH=${CMAKE_BINARY_DIR}/src/python ${SPHINX_PROGRAM} -b html
        ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR}/html
        COMMENT "Building html documentation"
    )
endif()
if(WITH_MAN)
    add_custom_target(doc-man ALL
        PYTHONPATH=${CMAKE_BINARY_DIR}/src/python ${SPHINX_PROGRAM} -b man
        ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR}/man
        COMMENT "Building manpage documentation"
    )
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/man/hawkey.3 DESTINATION share/man/man3)
endif()

=== docs/libdnf/CMakeLists.txt ===
configure_file("version.xml.in"  ${CMAKE_CURRENT_SOURCE_DIR}/version.xml)

if(WITH_GTKDOC)
    find_package(GtkDoc REQUIRED)

    if(GTKDOC_FOUND)
        add_custom_command(OUTPUT doc-scan
            COMMAND ${GTKDOC_SCAN_EXE}
            --source-dir=${CMAKE_SOURCE_DIR}/libdnf
            --module=libdnf
            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
        )

        add_custom_command(OUTPUT doc-mkdb
            COMMAND ${GTKDOC_MKDB_EXE}
            --sgml-mode
            --output-format=xml
            --module=libdnf
            --source-dir=${CMAKE_SOURCE_DIR}/libdnf
            DEPENDS doc-scan
            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
        )

        add_custom_command(OUTPUT doc-mkhtml
            COMMAND ${GTKDOC_MKHTML_EXE}
            libdnf
            ${CMAKE_SOURCE_DIR}/docs/libdnf/libdnf-docs.sgml
            DEPENDS doc-mkdb
            WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/html"
        )
        add_custom_target(doc-gtk DEPENDS doc-scan doc-mkdb doc-mkhtml)
    else()
        message(FATAL_ERROR "gtk-doc not found")
    endif()

    install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/html/ DESTINATION share/gtk-doc/html/libdnf)
endif()

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/conf.py.in ${CMAKE_CURRENT_BINARY_DIR}/conf.py)

add_custom_target(doxygen
    doxygen ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
    COMMENT "Building doxygen xml files"
)
add_custom_target(sphinx-html
    sphinx-build -c ${CMAKE_CURRENT_BINARY_DIR} -b html
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}/_build
    COMMENT "Building html documentation"
)
add_custom_target(doc)
add_dependencies(sphinx-html doxygen)
add_dependencies(doc sphinx-html)

=== libdnf/goal/CMakeLists.txt ===
set(GOAL_SOURCES
    ${GOAL_SOURCES}
    ${CMAKE_CURRENT_SOURCE_DIR}/Goal.cpp
    PARENT_SCOPE
)

=== libdnf/plugin/CMakeLists.txt ===
set(PLUGIN_SOURCES
    ${CMAKE_CURRENT_SOURCE_DIR}/plugin.cpp
    PARENT_SCOPE
)

set(PLUGIN_PUBLIC_HEADERS
    ${CMAKE_CURRENT_SOURCE_DIR}/plugin.h
)

install(FILES ${PLUGIN_PUBLIC_HEADERS} DESTINATION include/libdnf/plugin)

=== libdnf/repo/CMakeLists.txt ===
add_subdirectory(solvable)

set(REPO_SOURCES
    ${REPO_SOURCES}
    ${CMAKE_CURRENT_SOURCE_DIR}/Crypto.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/DependencySplitter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/Repo.cpp
    PARENT_SCOPE
)

set(REPO_HEADERS
    ${REPO_HEADERS}
    ${CMAKE_CURRENT_SOURCE_DIR}/Crypto.hpp
    ${CMAKE_CURRENT_SOURCE_DIR}/Repo.hpp
    PARENT_SCOPE
)

=== debian/changelog ===
libdnf (0.75.0-1) unstable; urgency=medium

  * Update upstream source from tag 'upstream/0.75.0'
  * Refresh patch for 0.75
  * d/control: bump Standards-Version to 4.7.2, no changes
  * d/copyright: use GPL URL instead of old FSF postal address

 -- Luca Boccassi <bluca@debian.org>  Fri, 24 Oct 2025 14:45:24 +0100

=== debian/control ===
Source: libdnf
Section: libs
Priority: optional
Maintainer: RPM packaging team <team+pkg-rpm@tracker.debian.org>
Uploaders: Frédéric Pierret <frederic.pierret@qubes-os.org>,
           Luca Boccassi <bluca@debian.org>,
Build-Depends: debhelper-compat (= 13),
 dh-package-notes,
 dh-sequence-python3,
 python3-dev,
 libpython3-dev,
 cmake,
 pkgconf,
 libglib2.0-dev,
 libsolv-dev (>= 0.7.14-1.1~),
 libsolvext-dev (>= 0.7.14-1.1~),
 libsolv-tools (>= 0.7.14-1.1~),
 librpm-dev (>= 4.19.1.1~),
 libzstd-dev,
 librepo-dev (>= 1.18.1~),
 gtk-doc-tools,
 python3-sphinx,
 check,
 libgpgme-dev,
 libssl-dev,
 libjson-c-dev,
 libmodulemd-dev (>= 2.11.2~),
 libsmartcols-dev,
 libsqlite3-dev,
 gettext,
 swig,
 libcppunit-dev,
 doxygen,
 python3-breathe,
 rpm-common (>= 4.19.1.1~),
Rules-Requires-Root: no
Standards-Version: 4.7.2
Homepage: https://github.com/rpm-software-management/libdnf
Vcs-Browser: https://salsa.debian.org/pkg-rpm-team/libdnf
Vcs-Git: https://salsa.debian.org/pkg-rpm-team/libdnf.git
#Testsuite: autopkgtest-pkg-python

Package: libdnf-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
 libdnf2t64 (= ${binary:Version}),
 libsolv-dev (>= 0.7.14-1.1~),
 libsolvext-dev (>= 0.7.14-1.1~),
Breaks: gir1.2-libdnf-1.0 (<< ${binary:Version}),
        libdnf2t64 (<< 0.73.1-1~), libdnf2 (<< 0.73.1-1~),
Replaces: libdnf2t64 (<< 0.73.1-1~), libdnf2 (<< 0.73.1-1~),
Description: libdnf - development files
 A library providing simplified C and Python APIs to libsolv.
 .
 This package contains the development header files for the
 libdnf library.

Package: libdnf2t64
Provides: libdnf, ${t64:Provides}
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends},
 libdnf2-common (= ${source:Version}),
Replaces: libdnf2,
Breaks: libdnf2 (<< ${source:Version}),
Description: libdnf - shared library
 A library providing simplified C and Python APIs to libsolv.
 .
 This package provides the libdnf shared library.

Package: libdnf2-common
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
Description: libdnf - common files
 A library providing simplified C and Python APIs to libsolv.
 .
 This package provides common files for the libdnf library.

Package: libdnf-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends},
Description: Documentation for the libdnf library (common documentation)
 A library providing simplified C and Python APIs to libsolv.
 .
 This package installs common documentation for the libdnf
 C bindings.

Package: python3-hawkey
Architecture: any
Multi-Arch: no
Section: python
Depends: ${shlibs:Depends}, ${python3:Depends}, ${misc:Depends},
 libdnf2t64 (= ${binary:Version}),
 python3-libdnf (= ${binary:Version}),
Provides: ${python3:Provides},
Suggests: python3-hawkey-docs
Description: Python bindings for the hawkey library (Python 3)
 A library providing simplified C and Python APIs to libsolv.
 .
 This package installs the hawkey library for Python 3.

Package: python3-hawkey-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${sphinxdoc:Depends}, ${misc:Depends},
         libjs-jquery, libjs-underscore,
Description: Python 3 bindings for the hawkey library (common documentation)
 A library providing simplified C and Python APIs to libsolv.
 .
 This package installs common documentation for the hawkey Python
 3 bindings.

Package: python3-libdnf
Architecture: any
Multi-Arch: no
Section: python
Depends: ${shlibs:Depends}, ${python3:Depends}, ${misc:Depends},
 libdnf2t64 (= ${binary:Version}),
Provides: ${python3:Provides},
Description: Python bindings for the libdnf library (Python 3)
 A library providing simplified C and Python APIs to libsolv.
 .
 This package installs the libdnf library for Python 3.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
# export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk
include /usr/share/debhelper/dh_package_notes/package-notes.mk

%:
	dh "${@}" --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure --builddirectory=build -- \
		-DWITH_BINDINGS:BOOL=ON \
		-DWITH_GTKDOC:BOOL=ON \
		-DWITH_HTML:BOOL=ON \
		-DWITH_MAN:BOOL=ON \
		-DENABLE_RHSM_SUPPORT:BOOL=OFF \
		-DENABLE_SOLV_URPMREORDER:BOOL=OFF \
		-DWITH_ZCHUNK:BOOL=OFF \
		-DCMAKE_INSTALL_PREFIX:PATH="/usr" \
		-DLIB:STRING="lib/$(shell dpkg-architecture -qDEB_BUILD_MULTIARCH)"

	sed -i -e '/^@LIBSMARTCOLS_COMPAT@/s/^@LIBSMARTCOLS_COMPAT@/\/\//' 'libdnf/utils/smartcols/Cell.hpp'; \

override_dh_auto_build:
	dh_auto_build --builddirectory=build -- all doc-html doc-gtk doc

override_dh_auto_install:
	dh_auto_install --builddirectory=build

	# Remove doctree files (redundant, conflicts with reproducible builds)
	rm -rfv 'build/docs/hawkey/html/.doctrees'

	# Use system-provides files.
	rm -fv 'build/docs/hawkey/html/_static/jquery.js' \
	       'build/docs/hawkey/html/_static/underscore.js' \
	       'build/docs/hawkey/html/_static/doctools.js' \
	       'build/docs/hawkey/html/_static/language_data.js' \
	       'build/docs/hawkey/html/_static/searchtools.js'

override_dh_auto_clean:
	rm -f 'libdnf/dnf-version.h'
	dh_auto_clean --builddirectory=build

override_dh_auto_test:
	mkdir -p '$(CURDIR)/debian/tests-home'
	LC_ALL=C HOME='$(CURDIR)/debian/tests-home' dh_auto_test --builddirectory=build -- ARGS='-V'

override_dh_installchangelogs:
	# Do not try to install a history directory within docs.
	dh_installchangelogs -Xhistory

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/(\d\S+)\.tar\.gz/libdnf-$1\.tar\.gz/ \
  https://github.com/rpm-software-management/libdnf/tags .*/@ANY_VERSION@\.tar\.gz
